﻿using UnityEngine;
using UnityEngine.SceneManagement;
using System.Collections.Generic;
using System;
using System.Text;

public class MaterialFixer : MVRScript
{
	private HashSet<Material> collectedMaterials = new HashSet<Material>();
	private int uiMask = 0;
	
	public override void Init()
	{
		OnEnable();
		
		/*StringBuilder builder = new StringBuilder();
		
		for (int n = 0; n < SceneManager.sceneCount; ++n)
		{
            Scene scene = SceneManager.GetSceneAt(n);				
			builder.Append(scene.name + " ================================\n");
			foreach (GameObject go in scene.GetRootGameObjects())
			{				
				foreach (DAZMesh smr in go.GetComponentsInChildren<DAZMesh>(true))
				{
					if (!smr.gameObject.activeInHierarchy || !smr.enabled)
						continue;
					
					string path = "";
					Transform t = smr.transform;
					while (t != null)
					{
						path = t.name + "/" + path;
						t = t.parent;
					}
					builder.Append(path).Append("\n");
				}
			}
		}
		
		SuperController.LogMessage(builder.ToString());*/
	}
	
 	private void OnEnable()
	{
		if (containingAtom == null)
			return; // not yet initialized...Init() will call us again.
		
		string path = "";
		Transform t = containingAtom.transform;
		while (t != null)
		{
			path = t.name + "/" + path;
			t = t.parent;
		}
		SuperController.LogMessage("containingAtom: " + path);
		
	
		try 
		{
			
		SuperController.LogMessage("OnEnable");
		
		Collect(containingAtom.transform);
		}
		catch (Exception e)
		{
			SuperController.LogError(e.ToString());
		}
	}
	
	private void OnDisable()
	{
		try 
		{
		SuperController.LogMessage("OnDisable");
		foreach (Material m in collectedMaterials)
			m.renderQueue -= 101;
		collectedMaterials.Clear();
		}
		catch (Exception e)
		{
			SuperController.LogError(e.ToString());
		}
	}
		
	private void Collect(Transform root)
	{		
		DAZMesh mesh = root.GetComponent<DAZMesh>();
		if (mesh != null)
		{
			if (mesh.simpleMaterial != null && collectedMaterials.Add(mesh.simpleMaterial))
			{
				mesh.simpleMaterial.renderQueue += 101;
				SuperController.LogMessage("Mat:"+ mesh.simpleMaterial + " # " + mesh.simpleMaterial.renderQueue);
			}			
			foreach (Material m in mesh.materials)
			{
				if (m != null && collectedMaterials.Add(m))
				{
					m.renderQueue += 101;
					SuperController.LogMessage("Mat:"+ m + " # " + m.renderQueue);
				}
			}
		}
		
		foreach (Transform child in root)
			Collect(child);
	}
}